import { __decorate } from "tslib";
import { attr, observable } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { foundationToastStyles as styles } from './toast.styles';
import { foundationToastTemplate as template } from './toast.template';
export const foundationToastShadowOptions = {
    mode: 'open',
    delegatesFocus: true,
};
export const defaultToastConfig = {};
export class Toast extends FoundationElement {
    constructor() {
        super(...arguments);
        this.deleteAnimation = '';
        this.closeTimeout = 10000;
        this.autoClose = false;
    }
    connectedCallback() {
        super.connectedCallback();
        if (this.autoClose) {
            setTimeout(() => {
                this.deleteAnimation = 'toast-delete';
                this.toast.onanimationend = () => {
                    this.remove();
                };
            }, this.closeTimeout);
        }
    }
    close() {
        this.remove();
    }
}
__decorate([
    observable
], Toast.prototype, "deleteAnimation", void 0);
__decorate([
    attr({ attribute: 'close-timeout' })
], Toast.prototype, "closeTimeout", void 0);
__decorate([
    attr({ attribute: 'auto-close' })
], Toast.prototype, "autoClose", void 0);
export const foundationToast = Toast.compose(Object.assign({ baseName: 'toast', styles,
    template, shadowOptions: foundationToastShadowOptions }, defaultToastConfig));
